/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.samplejson.servlet;

import com.liferay.portal.kernel.util.ParamUtil;
import com.liferay.portal.kernel.util.StringUtil;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;

/**
 * @author Ming-Gih Lam
 */
public class SampleJSONServlet extends HttpServlet {

	@Override
	public void service(
			HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException {

		String content = null;

		try {
			content = getContent(request, response);
		}
		catch (Exception e) {
			response.sendError(
				HttpServletResponse.SC_INTERNAL_SERVER_ERROR, e.getMessage());

			return;
		}

		response.setContentType("text/javascript");
		response.setHeader("Cache-Control", "no-cache");

		PrintWriter pw = response.getWriter();

		pw.write(content);

		pw.close();
	}

	protected String getContent(
			HttpServletRequest request, HttpServletResponse response)
		throws Exception {

		String id = ParamUtil.getString(request, "id");
		String callback = ParamUtil.getString(request, "callback");

		JSONObject jsonObj = new JSONObject();

		jsonObj.put("id", id);

		ServletContext servletContext = getServletContext();

		String script = StringUtil.read(
			servletContext.getResourceAsStream("/click_image.js"));

		String jsonObjString = jsonObj.toString();

		jsonObjString =
			jsonObjString.substring(0, jsonObjString.length() - 1) + "," +
				script + "}";

		return callback + "(" + jsonObjString + ");";
	}

}